Items = {
	platform = {
		stype = "drag",
		draw = function(x, y, w, h, self)
			lg.rectangle("fill", x, y, w, h)
		end,
		collide = function(self, v, dir)
			return {}
		end,
		drawPreview = function(x, y)
			Items.platform.draw(x+5, y+5, 40, 40)
		end,
		place = function(levelworld, x1, y1, x2, y2)
			table.insert(levelworld.elements, {t = "platform", x = x1, y = y1, w = x2-x1, h = y2-y1})
		end
	},
	spikeup = {
		stype = "place",
		draw = function(x, y, w, h, self)
			lg.polygon("fill", x, y+h,    x+w, y+h,     x + w/2, y)
		end,
		collide = function(self, v, dir)
			if dir == "x" and self.player.y+self.player.h<v.y+v.h then
				return {resetvel = false}
			else
				self:diePlayer()
				return {returnnow = true}
			end
		end,
		drawPreview = function(x, y)
			x, y = x+5, y+5
			Items.spikeup.draw(x, y, 40, 45)
		end,
		place = function(levelworld, x, y)
			table.insert(levelworld.elements, {t = "spikeup", x = x+5, y = y+5, w = 40, h = 45})
		end
	},
	spikedown = {
		stype = "place",
		draw = function(x, y, w, h, self)
			lg.polygon("fill", x, y,    x+w, y,     x + w/2, y+h)
		end,
		collide = function(self, v, dir)
			self:diePlayer()
			return {returnnow = true}
		end,
		drawPreview = function(x, y)
			x = x+5
			Items.spikedown.draw(x, y, 40, 45)
		end,
		place = function(levelworld, x, y)
			table.insert(levelworld.elements, {t = "spikedown", x = x+5, y = y, w = 40, h = 45})
		end
	},
	winplate = {
		stype = "place",
		draw = function(x, y, w, h, self)
			if self.onend then
				y = y+5
				h = h-5
				lg.setColor(0, 155, 0)

				if not self.oldonend then
					Sounds.winplate:play()
				end
			end
			lg.rectangle("fill", x, y, w, h)
		end,
		collide = function(self, v, dir)
			self.onend = true
			return {collide = false}
		end,
		drawPreview = function(x, y)
			Items.winplate.draw(x, y+40, 50, 10, {})
		end,
		place = function(levelworld, x, y)
			table.insert(levelworld.elements, {t = "winplate", x = x, y = y+40, w = 50, h = 10, col = {0,0,255}})
		end
	},
	text = {
		stype = "place",
		draw = function(x, y, w, h, self, v)
			lg.setFont(medFont)
			lg.print(v.text or "error", x, y)
		end,
		collide = function(self, v, dir)
			return {collide = false}
		end,
		drawPreview = function(x, y)
			lg.setFont(medFont)
			lg.print("ABC", x, y)
		end,
		place = function(levelworld, x, y)
			lg.setFont(medFont)
			local text = love.system.getClipboardText()
			text = string.gsub(text, "\r\n", "\n")
			local _, wraps = medFont:getWrap(text, 99999)
			table.insert(levelworld.elements, {t = "text", x = x, y = y, w = medFont:getWidth(text), h = medFont:getHeight()*wraps, text = text})
		end
	}
}

