lf = love.filesystem
ls = love.sound
la = love.audio
lp = love.physics
lt = love.thread
li = love.image
lg = love.graphics
lk = love.keyboard
lm = love.mouse

require("game")
require("world")
require("Tserial")
require("levels")
require("items")
require("sounds")
require("menu")
require("end")

font = lg.newFont("BebasNeue.otf", 60)
medFont = lg.newFont("BebasNeue.otf", 30)
smallfont = lg.newFont(12)
lg.setFont(font)

ConWorlds = {}
function love.load()
	Sounds_load()
	ConWorlds = {
		state = "menu",
		--game = Game.create(),
		menu = Menu.create(),
		debug = false,
		time = 0,
		deads = 0
	}
end
function love.update(dt)
	Music_update()
	if ConWorlds.state == "game" then
		ConWorlds.game:update(dt)
	elseif ConWorlds.state == "menu" then
		ConWorlds.menu:update(dt)
	end
end
function love.draw()
	if ConWorlds.state == "game" then
		ConWorlds.game:draw()
	elseif ConWorlds.state == "menu" then
		ConWorlds.menu:draw()
	elseif ConWorlds.state == "end" then
		ConWorlds.ends:draw()
	end
	lg.setFont(smallfont)
	-- lg.print("FPS"..love.timer.getFPS(), lg:getWidth()-200, 0)
end
function love.keypressed(k)
	if ConWorlds.state == "game" then
		ConWorlds.game:keypressed(k)
	elseif ConWorlds.state == "menu" then
		ConWorlds.menu:keypressed(k)
	elseif ConWorlds.state == "end" then
		ConWorlds.ends:keypressed(k)
	end
end
function love.mousepressed(x, y, button)
	if ConWorlds.state == "game" then
		ConWorlds.game:mousepressed(x, y, button)
	elseif  ConWorlds.state == "menu" then
		ConWorlds.menu:mousepressed(x, y, button)
	end
end
function love.mousereleased(x, y, button)
	if ConWorlds.state == "game" then
		ConWorlds.game:mousereleased(x, y, button)
	elseif ConWorlds.state == "menu" then

	end
end

function table.copy(t, deep, seen)
    seen = seen or {}
    if t == nil then return nil end
    if seen[t] then return seen[t] end

    local nt = {}
    for k, v in pairs(t) do
        if deep and type(v) == 'table' then
            nt[k] = table.copy(v, deep, seen)
        else
            nt[k] = v
        end
    end
    setmetatable(nt, table.copy(getmetatable(t), deep, seen))
    seen[t] = nt
    return nt
end

-- Collision detection function.
-- Returns true if two boxes overlap, false if they don't
-- x1,y1 are the left-top coords of the first box, while w1,h1 are its width and height
-- x2,y2,w2 & h2 are the same, but for the second box
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end